//1 bit Register(Master Slave DFF with A-Reset)
//Kamyar Rafati & Naeem Esfahani

module Reg_16bit_b (MData, Y, enable, reset, CLK);
	input	[15:0] MData;
	input	CLK, reset, enable;
	output	[15:0] Y;
	reg	[15:0] Y;

	reg		[15:0] Data;

	always @(posedge CLK)
	begin
		if (!reset && enable) Data = MData;
	end

	always @(negedge CLK)
	begin
		Y = Data;
	end

	always @(posedge reset)
	begin
		Data = 0;
	end
endmodule
