//1 bit Register
//Kamyar Rafati & Naeem Esfahani

module Reg_12bit (MData, Y, enable, reset, CLK);
	input	[11:0] MData;
	input	CLK, reset, enable;
	output	[11:0] Y;
	reg		[11:0] Data;

	assign Y = Data;
	always @(posedge CLK)
	begin
		if (!reset && enable) Data = MData;
	end

	always @(posedge reset)
	begin
		Data = 0;
	end
endmodule
