onerror {resume}
quietly WaveActivateNextPane {} 0
add wave -noupdate -format Logic /cpu/clk
add wave -noupdate -format Logic /cpu/reset
add wave -noupdate -format Literal /cpu/Op
add wave -noupdate -format Logic /cpu/i
add wave -noupdate -format Logic /cpu/IsFull
add wave -noupdate -format Logic /cpu/IsEmpty
add wave -noupdate -format Logic /cpu/WriteData
add wave -noupdate -format Logic /cpu/PCWrite
add wave -noupdate -format Logic /cpu/IorD
add wave -noupdate -format Logic /cpu/MemWrite
add wave -noupdate -format Logic /cpu/MemRead
add wave -noupdate -format Logic /cpu/IRWrite
add wave -noupdate -format Logic /cpu/RegWrite
add wave -noupdate -format Logic /cpu/zwe
add wave -noupdate -format Logic /cpu/nwe
add wave -noupdate -format Logic /cpu/cwe
add wave -noupdate -format Logic /cpu/iset
add wave -noupdate -format Logic /cpu/ireset
add wave -noupdate -format Logic /cpu/eset
add wave -noupdate -format Logic /cpu/ereset
add wave -noupdate -format Logic /cpu/Enq
add wave -noupdate -format Logic /cpu/Deq
add wave -noupdate -format Logic /cpu/PCWriteCond
add wave -noupdate -format Literal /cpu/AluA
add wave -noupdate -format Literal /cpu/AluB
add wave -noupdate -format Literal /cpu/PCSrc
add wave -noupdate -format Literal /cpu/RReg
add wave -noupdate -format Literal /cpu/RegDst
add wave -noupdate -format Literal /cpu/RegData
add wave -noupdate -format Literal /cpu/AluOp
add wave -noupdate -format Literal /cpu/DP/Op
add wave -noupdate -format Logic /cpu/DP/i
add wave -noupdate -format Logic /cpu/DP/IsFull
add wave -noupdate -format Logic /cpu/DP/IsEmpty
add wave -noupdate -format Logic /cpu/DP/WriteData
add wave -noupdate -format Logic /cpu/DP/PCWrite
add wave -noupdate -format Logic /cpu/DP/IorD
add wave -noupdate -format Logic /cpu/DP/MemWrite
add wave -noupdate -format Logic /cpu/DP/MemRead
add wave -noupdate -format Logic /cpu/DP/IRWrite
add wave -noupdate -format Logic /cpu/DP/RegWrite
add wave -noupdate -format Logic /cpu/DP/zwe
add wave -noupdate -format Logic /cpu/DP/nwe
add wave -noupdate -format Logic /cpu/DP/cwe
add wave -noupdate -format Logic /cpu/DP/iset
add wave -noupdate -format Logic /cpu/DP/ireset
add wave -noupdate -format Logic /cpu/DP/eset
add wave -noupdate -format Logic /cpu/DP/ereset
add wave -noupdate -format Logic /cpu/DP/Enq
add wave -noupdate -format Logic /cpu/DP/Deq
add wave -noupdate -format Logic /cpu/DP/PCWriteCond
add wave -noupdate -format Logic /cpu/DP/CLK
add wave -noupdate -format Logic /cpu/DP/reset
add wave -noupdate -format Literal /cpu/DP/AluA
add wave -noupdate -format Literal /cpu/DP/AluB
add wave -noupdate -format Literal /cpu/DP/PCSrc
add wave -noupdate -format Literal /cpu/DP/RReg
add wave -noupdate -format Literal /cpu/DP/RegDst
add wave -noupdate -format Literal /cpu/DP/RegData
add wave -noupdate -format Literal /cpu/DP/AluOp
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/WData
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/ALU
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/ALUOut
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/IR
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/MDR
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/RR1
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/RR2
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/MemInData
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/MemOut
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/QOut
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/QSize
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/A
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/B
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/SExtended
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/PCin
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/PCout
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/MemAddr
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/RR1Addr
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/WRAddr
add wave -noupdate -format Logic /cpu/DP/zero
add wave -noupdate -format Logic /cpu/DP/carry
add wave -noupdate -format Logic /cpu/DP/negative
add wave -noupdate -format Logic /cpu/DP/n
add wave -noupdate -format Logic /cpu/DP/c
add wave -noupdate -format Logic /cpu/DP/z
add wave -noupdate -format Logic /cpu/DP/e
add wave -noupdate -format Logic /cpu/DP/irest
add wave -noupdate -format Logic /cpu/DP/JCond
add wave -noupdate -format Logic /cpu/DP/PCW
add wave -noupdate -format Logic /cpu/DP/Cond
add wave -noupdate -format Logic /cpu/DP/Cond2
add wave -noupdate -format Logic /cpu/DP/PCCond
add wave -noupdate -format Literal /cpu/DP/PC/MData
add wave -noupdate -format Logic /cpu/DP/PC/CLK
add wave -noupdate -format Logic /cpu/DP/PC/reset
add wave -noupdate -format Logic /cpu/DP/PC/enable
add wave -noupdate -format Literal /cpu/DP/PC/Y
add wave -noupdate -format Literal /cpu/DP/PC/Data
add wave -noupdate -format Literal /cpu/DP/PCSelect/s
add wave -noupdate -format Literal /cpu/DP/PCSelect/a0
add wave -noupdate -format Literal /cpu/DP/PCSelect/a1
add wave -noupdate -format Literal /cpu/DP/PCSelect/a2
add wave -noupdate -format Literal /cpu/DP/PCSelect/a3
add wave -noupdate -format Literal /cpu/DP/PCSelect/y
add wave -noupdate -format Logic /cpu/DP/AddrSelect/s
add wave -noupdate -format Literal /cpu/DP/AddrSelect/a0
add wave -noupdate -format Literal /cpu/DP/AddrSelect/a1
add wave -noupdate -format Literal /cpu/DP/AddrSelect/y
add wave -noupdate -format Literal /cpu/DP/MainMem/ind
add wave -noupdate -format Literal /cpu/DP/MainMem/address
add wave -noupdate -format Logic /cpu/DP/MainMem/we
add wave -noupdate -format Logic /cpu/DP/MainMem/clk
add wave -noupdate -format Literal /cpu/DP/MainMem/outd
add wave -noupdate -format Logic /cpu/DP/MainMem/we_clk
add wave -noupdate -format Logic /cpu/DP/MainMem/re_clk
add wave -noupdate -format Literal /cpu/DP/InstReg/MData
add wave -noupdate -format Logic /cpu/DP/InstReg/CLK
add wave -noupdate -format Logic /cpu/DP/InstReg/reset
add wave -noupdate -format Logic /cpu/DP/InstReg/enable
add wave -noupdate -format Literal /cpu/DP/InstReg/Y
add wave -noupdate -format Literal /cpu/DP/InstReg/Data
add wave -noupdate -format Literal /cpu/DP/MDReg/MData
add wave -noupdate -format Logic /cpu/DP/MDReg/CLK
add wave -noupdate -format Logic /cpu/DP/MDReg/reset
add wave -noupdate -format Logic /cpu/DP/MDReg/enable
add wave -noupdate -format Literal /cpu/DP/MDReg/Y
add wave -noupdate -format Literal /cpu/DP/MDReg/Data
add wave -noupdate -format Logic /cpu/DP/MemWriteData/s
add wave -noupdate -format Literal /cpu/DP/MemWriteData/a0
add wave -noupdate -format Literal /cpu/DP/MemWriteData/a1
add wave -noupdate -format Literal /cpu/DP/MemWriteData/y
add wave -noupdate -format Literal /cpu/DP/RR1Select/s
add wave -noupdate -format Literal /cpu/DP/RR1Select/a0
add wave -noupdate -format Literal /cpu/DP/RR1Select/a1
add wave -noupdate -format Literal /cpu/DP/RR1Select/a2
add wave -noupdate -format Literal /cpu/DP/RR1Select/a3
add wave -noupdate -format Literal /cpu/DP/RR1Select/y
add wave -noupdate -format Literal /cpu/DP/WRSelect/s
add wave -noupdate -format Literal /cpu/DP/WRSelect/a0
add wave -noupdate -format Literal /cpu/DP/WRSelect/a1
add wave -noupdate -format Literal /cpu/DP/WRSelect/a2
add wave -noupdate -format Literal /cpu/DP/WRSelect/a3
add wave -noupdate -format Literal /cpu/DP/WRSelect/y
add wave -noupdate -format Literal /cpu/DP/RDSelect/s
add wave -noupdate -format Literal /cpu/DP/RDSelect/a0
add wave -noupdate -format Literal /cpu/DP/RDSelect/a1
add wave -noupdate -format Literal /cpu/DP/RDSelect/a2
add wave -noupdate -format Literal /cpu/DP/RDSelect/a3
add wave -noupdate -format Literal /cpu/DP/RDSelect/y
add wave -noupdate -format Literal /cpu/DP/RegFile/RAdr1
add wave -noupdate -format Literal /cpu/DP/RegFile/RAdr2
add wave -noupdate -format Literal /cpu/DP/RegFile/WAdr
add wave -noupdate -format Literal /cpu/DP/RegFile/WData
add wave -noupdate -format Logic /cpu/DP/RegFile/RegWrite
add wave -noupdate -format Logic /cpu/DP/RegFile/CLK
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/RegFile/Out1
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/RegFile/Out2
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/RegFile/Reg0
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/RegFile/Reg1
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/RegFile/Reg2
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/RegFile/Reg3
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/RegFile/Reg4
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/RegFile/Reg5
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/RegFile/Reg6
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/RegFile/Reg7
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/RegFile/Reg8
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/RegFile/Reg9
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/RegFile/Reg10
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/RegFile/Reg11
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/RegFile/Reg12
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/RegFile/Reg13
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/RegFile/Reg14
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/RegFile/Reg15
add wave -noupdate -format Literal -radix hexadecimal /cpu/DP/RegFile/Reg16
add wave -noupdate -format Literal /cpu/DP/AluSrcA/s
add wave -noupdate -format Literal /cpu/DP/AluSrcA/a0
add wave -noupdate -format Literal /cpu/DP/AluSrcA/a1
add wave -noupdate -format Literal /cpu/DP/AluSrcA/a2
add wave -noupdate -format Literal /cpu/DP/AluSrcA/a3
add wave -noupdate -format Literal /cpu/DP/AluSrcA/y
add wave -noupdate -format Literal /cpu/DP/AluSrcB/s
add wave -noupdate -format Literal /cpu/DP/AluSrcB/a0
add wave -noupdate -format Literal /cpu/DP/AluSrcB/a1
add wave -noupdate -format Literal /cpu/DP/AluSrcB/a2
add wave -noupdate -format Literal /cpu/DP/AluSrcB/a3
add wave -noupdate -format Literal /cpu/DP/AluSrcB/y
add wave -noupdate -format Literal /cpu/DP/SignExtend/a
add wave -noupdate -format Literal /cpu/DP/SignExtend/y
add wave -noupdate -format Literal /cpu/DP/Alu/A
add wave -noupdate -format Literal /cpu/DP/Alu/B
add wave -noupdate -format Literal /cpu/DP/Alu/Opcode
add wave -noupdate -format Literal /cpu/DP/Alu/y
add wave -noupdate -format Logic /cpu/DP/Alu/zero
add wave -noupdate -format Logic /cpu/DP/Alu/carry
add wave -noupdate -format Literal /cpu/DP/AluOutReg/MData
add wave -noupdate -format Logic /cpu/DP/AluOutReg/CLK
add wave -noupdate -format Logic /cpu/DP/AluOutReg/reset
add wave -noupdate -format Logic /cpu/DP/AluOutReg/enable
add wave -noupdate -format Literal /cpu/DP/AluOutReg/Y
add wave -noupdate -format Literal /cpu/DP/AluOutReg/Data
add wave -noupdate -format Logic /cpu/DP/CarryReg/MData
add wave -noupdate -format Logic /cpu/DP/CarryReg/CLK
add wave -noupdate -format Logic /cpu/DP/CarryReg/reset
add wave -noupdate -format Logic /cpu/DP/CarryReg/enable
add wave -noupdate -format Logic /cpu/DP/CarryReg/Y
add wave -noupdate -format Logic /cpu/DP/CarryReg/Data
add wave -noupdate -format Logic /cpu/DP/ZeroReg/MData
add wave -noupdate -format Logic /cpu/DP/ZeroReg/CLK
add wave -noupdate -format Logic /cpu/DP/ZeroReg/reset
add wave -noupdate -format Logic /cpu/DP/ZeroReg/enable
add wave -noupdate -format Logic /cpu/DP/ZeroReg/Y
add wave -noupdate -format Logic /cpu/DP/ZeroReg/Data
add wave -noupdate -format Logic /cpu/DP/NegativeReg/MData
add wave -noupdate -format Logic /cpu/DP/NegativeReg/CLK
add wave -noupdate -format Logic /cpu/DP/NegativeReg/reset
add wave -noupdate -format Logic /cpu/DP/NegativeReg/enable
add wave -noupdate -format Logic /cpu/DP/NegativeReg/Y
add wave -noupdate -format Logic /cpu/DP/NegativeReg/Data
add wave -noupdate -format Logic /cpu/DP/InterruptReg/CLK
add wave -noupdate -format Logic /cpu/DP/InterruptReg/reset
add wave -noupdate -format Logic /cpu/DP/InterruptReg/set
add wave -noupdate -format Logic /cpu/DP/InterruptReg/Y
add wave -noupdate -format Logic /cpu/DP/InterruptReg/Data
add wave -noupdate -format Logic /cpu/DP/ErrorReg/CLK
add wave -noupdate -format Logic /cpu/DP/ErrorReg/reset
add wave -noupdate -format Logic /cpu/DP/ErrorReg/set
add wave -noupdate -format Logic /cpu/DP/ErrorReg/Y
add wave -noupdate -format Logic /cpu/DP/ErrorReg/Data
add wave -noupdate -format Logic /cpu/DP/CD/out
add wave -noupdate -format Literal /cpu/DP/CD/OpCode
add wave -noupdate -format Logic /cpu/DP/CD/c
add wave -noupdate -format Logic /cpu/DP/CD/z
add wave -noupdate -format Logic /cpu/DP/CD/n
add wave -noupdate -format Logic /cpu/DP/CD/e
add wave -noupdate -format Literal /cpu/DP/Queue/InData
add wave -noupdate -format Logic /cpu/DP/Queue/Enq
add wave -noupdate -format Logic /cpu/DP/Queue/Deq
add wave -noupdate -format Logic /cpu/DP/Queue/clk
add wave -noupdate -format Logic /cpu/DP/Queue/IsFull
add wave -noupdate -format Logic /cpu/DP/Queue/IsEmpty
add wave -noupdate -format Logic /cpu/DP/Queue/Error
add wave -noupdate -format Literal /cpu/DP/Queue/Out
add wave -noupdate -format Literal /cpu/DP/Queue/Size
add wave -noupdate -format Literal /cpu/DP/Queue/Head
add wave -noupdate -format Literal /cpu/DP/Queue/Tail
add wave -noupdate -format Literal /cpu/DP/Queue/Count
add wave -noupdate -format Logic /cpu/DP/Queue/s
add wave -noupdate -format Literal /cpu/DP/Queue/Addr
add wave -noupdate -format Logic /cpu/DP/Queue/we
add wave -noupdate -format Logic /cpu/DP/Queue/re
add wave -noupdate -format Logic /cpu/DP/Queue/mux/s
add wave -noupdate -format Literal /cpu/DP/Queue/mux/a0
add wave -noupdate -format Literal /cpu/DP/Queue/mux/a1
add wave -noupdate -format Literal /cpu/DP/Queue/mux/y
add wave -noupdate -format Literal /cpu/DP/Queue/mem/ind
add wave -noupdate -format Literal /cpu/DP/Queue/mem/address
add wave -noupdate -format Logic /cpu/DP/Queue/mem/re
add wave -noupdate -format Logic /cpu/DP/Queue/mem/we
add wave -noupdate -format Logic /cpu/DP/Queue/mem/clk
add wave -noupdate -format Literal /cpu/DP/Queue/mem/outd
add wave -noupdate -format Logic /cpu/DP/Queue/mem/we_clk
add wave -noupdate -format Logic /cpu/DP/Queue/mem/re_clk
add wave -noupdate -format Literal /cpu/CTRL/Op
add wave -noupdate -format Logic /cpu/CTRL/clk
add wave -noupdate -format Logic /cpu/CTRL/reset
add wave -noupdate -format Logic /cpu/CTRL/i
add wave -noupdate -format Logic /cpu/CTRL/IsFull
add wave -noupdate -format Logic /cpu/CTRL/IsEmpty
add wave -noupdate -format Logic /cpu/CTRL/WriteData
add wave -noupdate -format Logic /cpu/CTRL/PCWrite
add wave -noupdate -format Logic /cpu/CTRL/IorD
add wave -noupdate -format Logic /cpu/CTRL/MemWrite
add wave -noupdate -format Logic /cpu/CTRL/MemRead
add wave -noupdate -format Logic /cpu/CTRL/IRWrite
add wave -noupdate -format Logic /cpu/CTRL/RegWrite
add wave -noupdate -format Logic /cpu/CTRL/zwe
add wave -noupdate -format Logic /cpu/CTRL/nwe
add wave -noupdate -format Logic /cpu/CTRL/cwe
add wave -noupdate -format Logic /cpu/CTRL/iset
add wave -noupdate -format Logic /cpu/CTRL/ireset
add wave -noupdate -format Logic /cpu/CTRL/eset
add wave -noupdate -format Logic /cpu/CTRL/ereset
add wave -noupdate -format Logic /cpu/CTRL/Enq
add wave -noupdate -format Logic /cpu/CTRL/Deq
add wave -noupdate -format Logic /cpu/CTRL/PCWriteCond
add wave -noupdate -format Literal /cpu/CTRL/AluA
add wave -noupdate -format Literal /cpu/CTRL/AluB
add wave -noupdate -format Literal /cpu/CTRL/PCSrc
add wave -noupdate -format Literal /cpu/CTRL/RReg
add wave -noupdate -format Literal /cpu/CTRL/RegDst
add wave -noupdate -format Literal /cpu/CTRL/RegData
add wave -noupdate -format Literal /cpu/CTRL/AluOp
add wave -noupdate -format Literal /cpu/CTRL/current
add wave -noupdate -format Literal /cpu/CTRL/next
TreeUpdate [SetDefaultTree]
WaveRestoreCursors {35 ns}
WaveRestoreZoom {0 ns} {152 ns}
configure wave -namecolwidth 213
configure wave -valuecolwidth 161
configure wave -justifyvalue left
configure wave -signalnamewidth 0
configure wave -snapdistance 10
configure wave -datasetprefix 0
configure wave -rowmargin 4
configure wave -childrowmargin 2
